#ifndef __ASYNC_H_INCLUDED__
#define __ASYNC_H_INCLUDED__

////////////////////////////////////////////////////////////////////
// class CAsyncClass : implements asynchronous data transfer in com
// 

class CAsyncClass
{
// Implemenation
public:
	CAsyncClass();
	virtual ~CAsyncClass();

// Attributes
private:
	DWORD	 m_dwError;
	bool	 m_bComplete;

public:
	DWORD GetError();
	void SetError(DWORD dw);
	void SetComplete(bool b);

// Operations
public:
	void DoRequestData();

	virtual void OnRequestData()=0;	
	virtual void OnNotifyComplete()=0;
};

/*

HOW TO USE THIS CLASS.

1.	Add the files async.h and async.cpp to your project.

2.	Create and inherit a new class from CAsyncClass.

3.	Add data members in your new class to hold the values returned 
	from your com server calls.

4. Optional: Add a Get/Set methods for your data members.

5.	Add an OnNotify method to your client inorder to extract the data
	from your class.

6.	Override the virtual method CAsyncClass::OnNotifyComplete to call
	the OnNotify method when the synchronous data transfer is complete.

7.	Override the virtual method OnRequestData to CREATE an interface to
	your com server object and request your data.
	NOTE: By the time OnReqestData is called, it will be operating in a
	separate thread. You cannot use an existing interface that was
	created in another thread.

8.	Add a method in your client to call CAsyncClass::DoRequestData.

FOR FURTHER REFERENCE, SEE THE DEMO PROGRAM FOR AN EXAMPLE.

*/

#endif



